﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace CountDownTimerEvent
{
    class CountDownDelegate
    {
        private readonly uint _seconds;

        // System.Action delegate: No parameter, nothing returned
        public Action Finished { get; set; }

        // Action<T> delegate: One parameter, nothing returned
        public Action<uint> Tick { get; set; }
        
        public CountDownDelegate(uint seconds)
        {
            _seconds = seconds;
        }

        public void Start()
        {
            new Thread(() =>
            {
                uint n = _seconds;
                while (n > 0u)
                {
                    if (Tick != null) Tick(n);
                    Thread.Sleep(1000);
                    n--;
                }
                if (Finished != null) 
                    Finished();
            }).Start();
        }
    }
}
