﻿using System;
using System.Threading;

namespace CountDownTimerEvent
{
    // Bart De Smet, page 850
    class CountDownEvent
    {
        private readonly uint _seconds;

        // Finished + Tick are not properties, but events
        public event Action Finished;

        public event Action<uint> Tick;

        public CountDownEvent(uint seconds)
        {
            _seconds = seconds;
        }

        public void Start()
        {
            new Thread(() =>
            {
                uint n = _seconds;
                while (n > 0u)
                {
                    if (Tick != null) Tick(n); // raise an event
                    Thread.Sleep(1000);
                    n--;
                }
                if (Finished != null) 
                    Finished(); // raise an event
            }).Start();
        }
    }
}
